cd figuresTHRESHOLDiv;  
hTS=1:10:120;  lambda=0.0609; tau=[1:1:120];

load deltabetaV; 
load irfoutputV_smooth; 
load irfinfV_smooth; 

%manually find rows corresponding to pictures in figure
R=[57; 29; 33; 43; 99; 75]; RL=['11/2001';' 9/1998';' 2/1999';' 5/2000'; ' 1/2007';' 1/2004'];
TS=[];
for j=1:6; rr=R(j);
  TS=[TS;deltabetaV(rr,3)+deltabetaV(rr,4)*(1-exp(-lambda*tau))./(lambda*tau)+deltabetaV(rr,5)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau))];
end;
fn=figure; subplot(1,2,1); p=plot(irfoutputV_smooth(R,:)'); set(p, {'Marker'}, {'^'; 'o'; '*'; 's';'.';'+'}); title('Output IRF'); %legend('11/2001',' 9/1998',' 2/1999',' 5/2000', ' 1/2007',' 1/2004','Location','Best');
subplot(1,2,2); p=plot(hTS,TS(:,hTS')'); axis tight; set(p, {'Marker'}, {'^'; 'o'; '*'; 's';'.';'+'}); title('Shock'); %legend('11/2001',' 9/1998',' 2/1999',' 5/2000', ' 1/2007',' 1/2004','Location','Best');

saveas(fn,'outputstate1', 'epsc'); 
fn=figure; subplot(1,2,1); p=plot(irfinfV_smooth(R,:)'); set(p, {'Marker'}, {'^'; 'o'; '*'; 's';'.';'+'}); title('Inflation IRF'); %legend('11/2001',' 9/1998',' 2/1999',' 5/2000', ' 1/2007',' 1/2004','Location','Best');
subplot(1,2,2); p=plot(hTS,TS(:,hTS')'); axis tight; set(p, {'Marker'}, {'^'; 'o'; '*'; 's';'.';'+'}); title('Shock'); legend('11/2001',' 9/1998',' 2/1999',' 5/2000', ' 1/2007',' 1/2004','Location','Best');
saveas(fn,'inflationstate1', 'epsc'); 

%**************************************************

%manually find rows corresponding to pictures in figure
R=[114; 115; 116; 118; 122; 125]; RL=['11/2008';'12/2008';' 1/2009';' 8/2010'; ' 9/2011';' 9/2012'];
TS=[];
for j=1:6; rr=R(j);
  TS=[TS;deltabetaV(rr,3)+deltabetaV(rr,4)*(1-exp(-lambda*tau))./(lambda*tau)+deltabetaV(rr,5)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau))];
end;
fn=figure; subplot(1,2,1); p=plot(irfoutputV_smooth(R,:)'); set(p, {'Marker'}, {'^'; 'o'; '*'; 's';'.';'+'}); title('Output IRF');  %legend('11/2008','12/2008',' 1/2009',' 8/2010', ' 9/2011',' 9/2012','Location','Best');
subplot(1,2,2); p=plot(hTS,TS(:,hTS')'); axis tight; set(p, {'Marker'}, {'^'; 'o'; '*'; 's';'.';'+'}); title('Shock'); %legend('11/2008','12/2008',' 1/2009',' 8/2010', ' 9/2011',' 9/2012','Location','NorthEast');
saveas(fn,'outputstate0', 'epsc'); 
fn=figure; subplot(1,2,1); p=plot(irfinfV_smooth(R,:)'); set(p, {'Marker'}, {'^'; 'o'; '*'; 's';'.';'+'}); title('Inflation IRF');  %legend('11/2008','12/2008',' 1/2009',' 8/2010', ' 9/2011',' 9/2012','Location','Best');
subplot(1,2,2); p=plot(hTS,TS(:,hTS')'); axis tight; set(p, {'Marker'}, {'^'; 'o'; '*'; 's';'.';'+'}); title('Shock'); legend('11/2008','12/2008',' 1/2009',' 8/2010', ' 9/2011',' 9/2012','Location','NorthEast');
saveas(fn,'inflationstate0', 'epsc'); 

cd ..