
load TSbeforeV; load TSafterV; 
before=TSbeforeV(75,:); %pick 1/2004
after=TSafterV(75,:); %pick 1/2004
shock=after-before;
tau=[1:1:120]; lambda= 0.0609;

fn=figure; 
plot(tau,before,'--m','LineWidth',2); hold on; 
plot(tau(1,[1:10:120]),after(1,[1:10:120]),'--*m','LineWidth',2,'MarkerSize',12); hold off; axis tight; 
legend('Term Structure Before','Term Structure After','Location','Best'); 
xlabel('Maturity');
title('Term Structure on 2004:1')
set(gca,'FontSize',12)
saveas(fn,'MPshock1', 'epsc')


fn=figure; plot(tau,shock,'--m','LineWidth',3); axis tight; 
legend('Shock on 2004:1','Location','Best'); 
xlabel('Maturity');
title('Monetary Policy Shock')
set(gca,'FontSize',12)
saveas(fn,'MPshock2', 'epsc')

