function main_threshold(betaT,day,month,year,TimeV,mpdates,Y,Z,select_beta,state,p,folder,wantOLS); 
B = 1000;
H = 10; 

nbeta=size(select_beta,2);
lambda = 0.0609;

result=deltabeta3(mpdates,betaT,lambda,year,month,day,TimeV);
shock=result.shock;   
betabeforeV=result.betabeforeV;  
betaafterV =result.betaafterV;   
deltabetaV=[]; deltabetaV2SLS=[]; deltabetaV1=[];
irfinfV=[]; irfoutputV=[];
irf_inf1=[]; irf_output1=[]; irf_inf0=[]; irf_output0=[]; 

if wantOLS==0; cd figuresTHRESHOLDiv; save shock shock -ascii; save betabeforeV betabeforeV -ascii; cd ..
elseif wantOLS==1; cd figuresTHRESHOLDols; save shock shock -ascii; save betabeforeV betabeforeV -ascii; cd ..
end;

%Instrument
Zv=fromshockonlytoeverydate(mpdates,Z,year,month,TimeV);

shockhere=shock(61:end-6,select_beta);    Yhere=Y(61:end,:);  Zhere=Zv(61:end-6,4:end); select_instrum=[1,2,3,4];  
shockhereT=shock(61:end-6,:); ZhereT=Zv(61:end-6,:); dummyT=[state(:,1:2),state(:,end)>0.75]; %this line can be del

dummy=state(:,end)>0.75; 
dummyT=[state(:,[1,2]),dummy];

shockhere2SLS=Zhere*(inv(Zhere'*Zhere))*(Zhere'*shockhere); %first-stage 2SLS fitted regressor
if wantOLS==0; cd figuresTHRESHOLDiv; save shockhere2SLS shockhere2SLS -ascii;  save shockhere shockhere -ascii;  cd ..
elseif wantOLS==1; cd figuresTHRESHOLDols; save shockhere shockhere -ascii;  cd ..
end;

irf_inf=[]; irf_output=[]; irf_output1=[]; irf_output1check=[]; p=2; %p=2 means 1 lag
Virf_inf=zeros(nbeta,nbeta,H); Virf_output=zeros(nbeta,nbeta,H);

for h=1:H; 
  if wantOLS==1;
    %OLS regressions 
    qn=2; 
    dummy=state(:,end)>0.75;   
        uno=ones(size(Yhere,1),1);
        laghdummy=[nan*ones(h,1); dummy(1:end-h,:)]; 
        laghshockhere=[[nan*ones(h,size(shockhere,2)); shockhere(1:end-h,:)], ...
            [nan*ones(h,size(Yhere,2)); Yhere(1:end-h,:)], ...
            [nan*ones(h+(p-1),size(shockhere,2)); shockhere(1:end-h-1,:)], ...
            [nan*ones(h+(p-1),size(Yhere,2)); Yhere(1:end-h-1,:)] ];
        %doing the dummy regression with dummy and (1-dummy)
        %IRFs for dt=1 (state>0.75)
        Y2b=Yhere;   
        X2b=[mmult(laghdummy,laghshockhere),mmult(1-laghdummy,laghshockhere),laghdummy,1-laghdummy]; 
        IRFoutputhere1=gmmbetaHAC(Y2b(h+2:end,2),X2b(h+2:end,:),X2b(h+2:end,:),1,qn)',  
        irf_output1=[irf_output1; IRFoutputhere1(1:nbeta)];
        IRFinfhere1=gmmbetaHAC(Y2b(h+2:end,1),X2b(h+2:end,:),X2b(h+2:end,:),1,qn)',
        irf_inf1=[irf_inf1; IRFinfhere1(1:nbeta)]; 
        Y20=Yhere;   
        X20=[mmult(1-laghdummy,laghshockhere),mmult(laghdummy,laghshockhere),1-laghdummy,laghdummy]; 
        IRFoutputhere0=gmmbetaHAC(Y20(h+2:end,2),X20(h+2:end,:),X20(h+2:end,:),1,qn)',  
        irf_output0=[irf_output0; IRFoutputhere0(1:nbeta)];
        IRFinfhere0=gmmbetaHAC(Y20(h+2:end,1),X20(h+2:end,:),X20(h+2:end,:),1,qn)',
        irf_inf0=[irf_inf0; IRFinfhere0(1:nbeta)]; 
                
  elseif wantOLS==0;     qn=2;
    %IV regressions 
    %define interactions
    dummy=state(:,end)>0.75;  
        uno=ones(size(Yhere,1),1);
        laghdummy=[nan*ones(h,1); dummy(1:end-h,:)]; 
        laghshockhere=[[nan*ones(h,size(shockhere,2)); shockhere(1:end-h,:)], ...
            [nan*ones(h,size(Yhere,2)); Yhere(1:end-h,:)], ...
            [nan*ones(h+(p-1),size(shockhere,2)); shockhere(1:end-h-1,:)], ...
            [nan*ones(h+(p-1),size(Yhere,2)); Yhere(1:end-h-1,:)] ];
        laghZhere=[[nan*ones(h,size(Zhere(:,select_instrum),2)); Zhere(1:end-h,select_instrum)], ...
            [nan*ones(h,size(Yhere,2)); Yhere(1:end-h,:)], ...
            [nan*ones(h+(p-1),size(Zhere(:,select_instrum),2)); Zhere(1:end-h-1,select_instrum)], ...
            [nan*ones(h+(p-1),size(Yhere,2)); Yhere(1:end-h-1,:)]  ];
        %doing the dummy regression with dummy and (1-dummy)
        %IRFs for dt=1 (state>0.75)
        Y2b=Yhere;   
        X2b=[mmult(laghdummy,laghshockhere),mmult(1-laghdummy,laghshockhere),laghdummy,1-laghdummy]; 
        Z2b=[mmult(laghdummy,laghZhere),mmult(1-laghdummy,laghZhere),laghdummy,1-laghdummy]; 
        IRFoutputhere1=gmmbetaHAC1(Y2b(h+2:end,2),X2b(h+2:end,:),Z2b(h+2:end,:),1,qn)';
        irf_output1=[irf_output1; IRFoutputhere1(1:nbeta)];
        IRFinfhere1=gmmbetaHAC1(Y2b(h+2:end,1),X2b(h+2:end,:),Z2b(h+2:end,:),1,qn)';
        irf_inf1=[irf_inf1; IRFinfhere1(1:nbeta)]; 
        %IRFs for dt=0 (state<0.75)
        Y20=Yhere;   
        X20=[mmult(1-laghdummy,laghshockhere),mmult(laghdummy,laghshockhere),1-laghdummy,laghdummy]; 
        Z20=[mmult(1-laghdummy,laghZhere),mmult(laghdummy,laghZhere),1-laghdummy,laghdummy]; 
        IRFoutputhere0=gmmbetaHAC1(Y20(h+2:end,2),X20(h+2:end,:),Z20(h+2:end,:),1,qn)'; 
        irf_output0=[irf_output0; IRFoutputhere0(1:nbeta)];
        IRFinfhere0=gmmbetaHAC1(Y20(h+2:end,1),X20(h+2:end,:),Z20(h+2:end,:),1,qn)'; 
        irf_inf0=[irf_inf0; IRFinfhere0(1:nbeta)]; 
   end;      
end; 
 
%Impose impact=0
irf_inf0=[irf_inf0(1,:).*0; irf_inf0(1:end,:)];
irf_output0=[irf_output0(1,:).*0; irf_output0(1:end,:)]; 
irf_output0=smooth(irf_output0); irf_inf0=smooth(irf_inf0);   
irf_inf1=[irf_inf1(1,:).*0; irf_inf1(1:end,:)];
irf_output1=[irf_output1(1,:).*0; irf_output1(1:end,:)];   
irf_output1=smooth(irf_output1); irf_inf1=smooth(irf_inf1);  

BB3=[];

for tt=1:size(shock,1)-6
    if sum(abs(shock(tt,4:6)))<eps
        continue
    end
        
    if state(tt-61+1,end)>0.75;
        irf_inf=irf_inf1 ; irf_output=irf_output1; 
    elseif state(tt-61+1,end)<0.75;   
        irf_inf=irf_inf0 ; irf_output=irf_output0; 
    end

   BB3=[BB3;tt-60];   
   irf_inf50=[];      
   irf_output50=[];   

   for hindex=1:H;  
    %Frechet derivatives
    irf_inf50    = [irf_inf50,irf_inf(hindex,:)*shock(tt,select_beta)'];
    irf_output50 = [irf_output50,irf_output(hindex,:)*shock(tt,select_beta)'];

   end
   
      decomp_inf     = bsxfun(@times,irf_inf,shock(tt,select_beta));
      decomp_output  = bsxfun(@times,irf_output,shock(tt,select_beta)); 

    %%%%%%%%%%%%%%%%%%%%%
    %%% IRF INFLATION %%%
    %%%%%%%%%%%%%%%%%%%%%
            
    if nbeta<4; %when nbeta==2 plot the change in NS
        betabefore=betabeforeV(tt,:); 
        betaafter=betaafterV(tt,:); 
        betadiff=betaafter-betabefore;
        tau=[1:1:120];
        TS_before=betabefore(1,4)+betabefore(1,5)*(1-exp(-lambda*tau))./(lambda*tau)+betabefore(1,6)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
        TS_after=betaafter(1,4)+betaafter(1,5)*(1-exp(-lambda*tau))./(lambda*tau)+betaafter(1,6)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
        TS_diff=betadiff(1,4)+betadiff(1,5)*(1-exp(-lambda*tau))./(lambda*tau)+betadiff(1,6)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
        
        betadiff2=shockhere2SLS(BB3(end),:); 
        TS_diff2=betadiff2(1,4-3)+betadiff2(1,5-3)*(1-exp(-lambda*tau))./(lambda*tau)+betadiff2(1,6-3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
        deltabetaV=[deltabetaV; betabefore(2), betabefore(1), betadiff(1,4), betadiff(1,5), betadiff(1,6), betadiff(1,4)+betadiff(1,5), betadiff(1,6)-betadiff(1,4) ];
        deltabetaV2SLS=[deltabetaV2SLS; betabefore(2), betabefore(1), shockhere2SLS(BB3(end),1), shockhere2SLS(BB3(end),2), shockhere2SLS(BB3(end),3), shockhere2SLS(BB3(end),1)+shockhere2SLS(BB3(end),2), shockhere2SLS(BB3(end),3)-shockhere2SLS(BB3(end),1) ];
        irfinfV=[irfinfV; irf_inf50];
        decomp_infV=[decomp_infV; ];
    end;
    
    if nbeta<4; %PLOT DECOMPOSITION INFLATION
        fn=figure('visible','off'); 
        plot(decomp_inf(:,1),'o:'); hold on; 
        plot(decomp_inf(:,2),'x:');  
        plot(decomp_inf(:,3)); hold off;
        ylabel('Percent','FontSize',14); xlabel('Horizon','FontSize',14); 
        lgd=legend('\Delta\beta_1_t','\Delta\beta_2_t','\Delta\beta_3_t','Location','Best'); lgd.FontSize = 14; 
        str3=['title(''Decomposition of Inflation IRF on ',num2str(shock(tt,2)),'/',num2str(shock(tt,1)),''',''FontSize'',14',');']; 
        eval(str3);  
        saveas(fn,strcat(folder,'/inflation_decomp',num2str(shock(tt,2)),num2str(shock(tt,1))), 'epsc')
        close;
            
    end;

    %%%%%%%%%%%%%%%%%%
    %%% IRF OUTPUT %%%
    %%%%%%%%%%%%%%%%%%
    if nbeta<4; %when nbeta==2 plot the change in NS
        irfoutputV=[irfoutputV; irf_output50];
    end;
    close;  
    
    if nbeta<4; %PLOT DECOMPOSITION FOR OUTPUT
        fn=figure; %figure('visible','off'); 
        plot(decomp_output(:,1),'o:'); hold on; 
        plot(decomp_output(:,2),'x:');  
        plot(decomp_output(:,3)); 
        hold off; 
        ylabel('Percent','FontSize',14); xlabel('Horizon','FontSize',14); 
        lgd=legend('Contribution of \Delta\beta_1_t','Contribution of \Delta\beta_2_t','Contribution of \Delta\beta_3_t','Location','Best'); lgd.FontSize = 14;
        str3=['title(''Decomposition of IRF of Output on ',num2str(shock(tt,2)),'/',num2str(shock(tt,1)),''',''FontSize'',14',');']; 
        eval(str3);
        saveas(fn,strcat(folder,'/output_decomp',num2str(shock(tt,2)),num2str(shock(tt,1))), 'epsc')
        close; 
                
    end;

end

irf_output_smooth_state0=irf_output0(1:6,:); 
irf_output_smooth_state1=irf_output1(1:6,:); 
irf_inf_smooth_state0=irf_inf0(1:6,:); 
irf_inf_smooth_state1=irf_inf1(1:6,:); 


    str=['cd',' ',folder]; eval(str);
    disp(deltabetaV); save deltabetaV deltabetaV -ascii;   
    disp(deltabetaV2SLS); save deltabetaV2SLS deltabetaV2SLS -ascii;  
    save irfinfV_smooth irfinfV -ascii;   
    save irfoutputV_smooth irfoutputV -ascii;   
    
    save irf_output_smooth_state1 irf_output_smooth_state1 -ascii;   
    save irf_inf_smooth_state1 irf_inf_smooth_state1 -ascii;   
    save irf_output_smooth_state0 irf_output_smooth_state0 -ascii;   
    save irf_inf_smooth_state0 irf_inf_smooth_state0 -ascii;  
    
    save betabeforeV betabeforeV -ascii;   
    save betaafterV betaafterV -ascii;   
    save shock shock -ascii;   
    cd .. 


