%  Takeaway point for LP-IV THRESHOLD MODEL

load figuresTHRESHOLDiv\irf_output_smooth_state0
H=6;
tau=[1:10:120]; 
irf_output=irf_output_smooth_state0(1:H,:);  
fn=figure; 
ddV=[[0.02:-0.01:-0.02]',[-0.02:0.01:0.02]',[-0.05:0.025:0.05]'];
d= [0.0200   -0.0200   -0.0500];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,':r','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d',':r','LineWidth',3); hold on; axis tight; %pause;
d=[0.0100   -0.0100   -0.0250];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'-^g','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d','-^g','LineWidth',3); hold on; axis tight; %pause;
d=[     0         0         0];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'s','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d','s','LineWidth',3); hold on; axis tight; %pause;
d=[-0.0100    0.0100    0.0250];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'-*c','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d','-*c','LineWidth',3); hold on; axis tight; %pause;
d=[-0.0200    0.0200    0.0500];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'-.m','LineWidth',3); xlabel('Maturity'); ylabel('Percent');
axis tight; hold on; subplot(1,2,1); plot(irf_output*d','-.m','LineWidth',3); ylabel('Percent'); xlabel('Horizon'); hold on; axis tight; %pause;
hold off;
saveas(fn,'figuresTHRESHOLDiv/takeaways/deltabeta123State0', 'epsc')



%FIGURE 1
fn=figure; 
d= [0.16   -0.1   -0.1];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,':r','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d',':r','LineWidth',3); hold on; axis tight; %pause;
d=[0.08   -0.1   -0.1];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'-^g','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d','-^g','LineWidth',3); hold on; axis tight; %pause;
d=[0   -0.1   -0.1];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'s','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d','s','LineWidth',3); hold on; axis tight; %pause;
d=[-0.08   -0.1   -0.1];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'-*c','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d','-*c','LineWidth',3); hold on; axis tight; %pause;
d=[-0.16   -0.1   -0.1];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'-.m','LineWidth',3); axis tight; hold on; xlabel('Maturity'); ylabel('Percent');
subplot(1,2,1); plot(irf_output*d','-.m','LineWidth',3); hold on; xlabel('Horizon'); ylabel('Percent'); 
axis tight;  hold off;
saveas(fn,'figuresTHRESHOLDiv/takeaways/deltabeta1State0', 'epsc');
 
%FIGURE 2   
fn=figure; 
d= [0   0.04   0];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,':r','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d',':r','LineWidth',3); hold on; axis tight; %pause;
d=[0   0.02   0];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'-^g','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d','-^g','LineWidth',3); hold on; axis tight; %pause;
d=[0   0   0];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'s','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d','s','LineWidth',3); hold on; axis tight; %pause;
d=[0   -0.02   0];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'-*c','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d','-*c','LineWidth',3); hold on; axis tight; %pause;
d=[0   -0.04   0];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'-.m','LineWidth',3); axis tight; hold on; xlabel('Maturity'); ylabel('Percent');
subplot(1,2,1); plot(irf_output*d','-.m','LineWidth',3); hold on; xlabel('Horizon'); ylabel('Percent'); 
axis tight;  hold off;
saveas(fn,'figuresTHRESHOLDiv/takeaways/deltabeta2State0', 'epsc');


%FIGURE 3   
fn=figure; 
d= [0   0   0.04];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,':r','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d',':r','LineWidth',3); hold on; axis tight; %pause;
d=[0   0   0.02];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'-^g','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d','-^g','LineWidth',3); hold on; axis tight; %pause;
d=[0   0   0];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'s','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d','s','LineWidth',3); hold on; axis tight; %pause;
d=[0   0   -0.02];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'-*c','LineWidth',3); axis tight; hold on; subplot(1,2,1); plot(irf_output*d','-*c','LineWidth',3); hold on; axis tight; %pause;
d=[0   0   -0.04];
TS_diff2=d(1)+d(2)*(1-exp(-lambda*tau))./(lambda*tau)+d(3)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
subplot(1,2,2); plot(tau,TS_diff2,'-.m','LineWidth',3); axis tight; hold on; xlabel('Maturity'); ylabel('Percent');
subplot(1,2,1); plot(irf_output*d','-.m','LineWidth',3); hold on; xlabel('Horizon'); ylabel('Percent'); 
axis tight;  hold off;
saveas(fn,'figuresTHRESHOLDiv/takeaways/deltabeta3State0', 'epsc');