%Predictive densities real GDP growth
x=6.5:-1:-3.5;
%2019	4	
before=[0.00	0.03	0.58	3.38	76.92	16.18	2.29	0.48	0.10	0.03	0.00];
%2020	1	
after=[0.00	0.06	0.52	6.50	38.60	39.53	11.73	2.78	0.25	0.03	0.00];
shock=after-before;

fn=figure; subplot(2,1,1); bar(x,before); ylabel('Probability');
axis tight;  
title('Predictive Density 2019Q4'); xlabel('Real Output Growth Rate'); 
set(gca,'FontSize',12); 
subplot(2,1,2); bar(x,after); ylabel('Probability');
axis tight;  
title('Predictive Density 2020Q1'); xlabel('Real Output Growth Rate'); 
set(gca,'FontSize',12); saveas(fn,'Outputdensity', 'epsc')

fn=figure; bar(x,shock); 
axis tight;  
title('Output Shock 2020Q1'); xlabel('Real Output Growth Rate'); 
set(gca,'FontSize',12); saveas(fn,'Outputshock', 'epsc')


