function Zv=fromdailytomonthly(Z,year1,month1,year2,month2);
%Constructs a series from daily data to monthly (end of the month)
%INPUTS: year1 month1 is the first date you want the dataset
%        year2 month2 is the final date you want the dataset
%        input daily data are called Z and their time is in the first three
%        columns of Z (time is as follows: day, month, year then the data) <= only change here

Zv  =[];    
for ty=year1:year2; %ty, 
    if ty==year1; tmV=month1:1:12; elseif ty==year2; tmV=1:1:month2; else; tmV=1:1:12; end; 
    
    for tm=tmV; %tm, %tm, mpdates(1,3), mpdates(2,3)
  
     [i_shock]=find( Z(:,3)==ty &  Z(:,2)==tm ); %pause;  
     
     if isempty(i_shock)==1; 
         Zv  =[Zv;   ty,tm, ty+(tm-1)/12,zeros(1,size(Z,2)-3)]; 
     else;
         %shockV_ii_avg=[]; 
         %for ii=i_shock';  
         %[i_beta]=find( Z(:,1)==mpdates(ii,1) &  Z(:,2)==mpdates(ii,2) &  Z(:,3)==mpdates(ii,3) ),
        %Z(i_shock,4:end), pause;  mean(Z(i_shock,4:end),1), pause; 
         shockV_ii_avg   =[ty, tm, ty+(tm-1)/12, mean(Z(i_shock,4:end),1)];
        % Zv   =[Zv; Z(i_beta,[1,2]), ty+(tm-1)/12, Z(i_beta+1,4:end)];
        % end;
        % shockV_ii_avg
         Zv=[Zv; shockV_ii_avg(end,:)];
     end;
     
    end;
end; 


